//+------------------------------------------------------------------+
//|                                     Check_FileMappingMT4.dll.mq4 |
//|                                     Copyright  Zhunko           |
//|                                     vadim@zhunko.ru              |
//+------------------------------------------------------------------+
//|            |
//|      .        |
//+------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property show_inputs
#include <FileMappingMT4.mqh> //    "TimeSeriesMT4.dll".
//
extern bool   CheckWriteRead = false;                       //  /   .
extern bool   CheckWrite     = false;                       //     .
extern bool   CheckRead      = false;                       //     .
extern bool   CheckGeneral   = false;                       //   .
extern string NamePrefix     = "Loc";                       //         .
extern string NameFileMap0   = "Local\Check_FileMapping0";  //    .     : "Global\"  "Local\".
extern string NameFileMap1   = "Local\Check_FileMapping1";  //    .
extern string NameFileMap2   = "Local\Check_FileMapping2";  //    .
extern string NameFileMap3   = "Local\Check_FileMapping3";  //    .
extern string NameFileMap4   = "Global\Check_FileMapping4"; //    .
extern int    MemorySize     = 64000;                       //      .
extern int    StartByte      = 0;                           //      ,     .
extern bool   bValue         = true;                        //   BOOL.
extern int    cValue         = 123;                         //   CHAR.
extern int    ucValue        = 255;                         //   UNSIGNED CHAR.
extern int    shValue        = 32100;                       //   SHORT.
extern int    ushValue       = 65535;                       //   UNSIGNED SHORT.
extern int    nValue         = 2147012345;                  //   INT.
extern double fValue         = 1234.56789012;               //   FLOAT.
extern double dValue         = 1234.56789012;               //   DOUBLE.
extern string sValue0        = " = 1234.56789";     //   STRING.
extern string sValue1        = " = 9876.54321";     //   STRING.
extern string sValue2        = " !!!";             //   STRING.
extern string sValue3        = " !";                 //   STRING.
extern string sValue4        = "  ";         //   STRING.
//
void start()
 {
  int    i = 0;
  int    hMapping = NULL;
  int    nAddress = NULL;
  string sComment = "";
  //    .
  string sBuffer25 = "                         "; //    .
  string sBuffer50 = "                                                  "; //    .
  string sBufferClaer50 = "                                                  "; //     .
  //   .
  bool   abOutArray[10] = {true, false, true, false, true, true, true, false, false, false};
  int    acOutArray[10] = {-128, -93, -70, -25, 0, 25, 56, 86, 96, 127};
  int    aucOutArray[10] = {0, 54, 75, 123, 150, 175, 199, 210, 230, 255};
  int    ashOutArray[10] = {-32768, -22210, -16789, -8765, 0, 4567, 8907, 16789, 22456, 32767};
  int    aushOutArray[10] = {0, 1210, 3789, 4765, 50764, 12567, 18907, 35789, 45456, 65535};
  int    aiOutArray[10] = {-2147483648, -1147432001, -16789, -8765, 0, 4567, 8907, 16789, 1147432001, 2147483647};
  double afOutArray[10] = {-21474.3200112345, -11474.3200112345, -16.78912345, -876.512345, 0, 45671.2345612345, 890712.345678912, 167891.234567891, 1147432.00112345, 214743.200112345};
  double adOutArray[10] = {-21474.3200112345, -11474.3200112345, -16.78912345, -876.512345, 0, 45671.2345612345, 890712.345678912, 167891.234567891, 1147432.00112345, 214743.200112345};
  //   .
  bool   abIncArray[10] = {0};
  int    acIncArray[10] = {0};
  int    aucIncArray[10] = {0};
  int    ashIncArray[10] = {0};
  int    aushIncArray[10] = {0};
  int    aiIncArray[10] = {0};
  double afIncArray[10] = {0};
  double adIncArray[10] = {0};
  //xxxx  /   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckWriteRead)
   {//====   . ==========================================================================================================================================
    hMapping = FileMapCreate(NULL, NameFileMap0, MemorySize); //  .
    sComment = " \"" + NameFileMap0 + "\" . : " + hMapping + "\n\n";
    Comment(sComment);
//    hMapping = FileMapOpen(NameFileMap0);
//    sComment = sComment + " . : " + hMapping + "\n\n";
//    Comment(sComment);
    //====  /   . ====================================================================================================================================
    sComment = sComment + "   BOOL: (" + FileMapWriteBool(NameFileMap0, StartByte, bValue) + ")  " + bValue + "\n";
    Comment(sComment);
    sComment = sComment + "   BOOL:             " + FileMapReadBool(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + FileMapWriteChar(NameFileMap0, StartByte, cValue) + ")  " + cValue + "\n";
    Comment(sComment);
    sComment = sComment + "   CHAR:             " + FileMapReadChar(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED CHAR: (" + FileMapWriteUnsChar(NameFileMap0, StartByte, ucValue) + ")  " + ucValue + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED CHAR:             " + FileMapReadUnsChar(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   SHORT: (" + FileMapWriteShort(NameFileMap0, StartByte, shValue) + ")  " + shValue + "\n";
    Comment(sComment);
    sComment = sComment + "   SHORT:             " + FileMapReadShort(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED SHORT: (" + FileMapWriteUnsShort(NameFileMap0, StartByte, ushValue) + ")  " + ushValue + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED SHORT:             " + FileMapReadUnsShort(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   INT: (" + FileMapWriteInt(NameFileMap0, StartByte, nValue) + ")  " + nValue + "\n";
    Comment(sComment);
    sComment = sComment + "   INT:             " + FileMapReadInt(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   FLOAT: (" + FileMapWriteFloat(NameFileMap0, StartByte, fValue) + ")  " + fValue + "\n";
    Comment(sComment);
    sComment = sComment + "   FLOAT:             " + FileMapReadFloat(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   DOUBLE: (" + FileMapWriteDouble(NameFileMap0, StartByte, dValue) + ")  " + dValue + "\n";
    Comment(sComment);
    sComment = sComment + "   DOUBLE:             " + FileMapReadDouble(NameFileMap0, StartByte) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   STRING: (" + FileMapWriteString(NameFileMap0, StartByte, sValue0) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + FileMapReadString(NameFileMap0, StartByte, sBuffer50, StringLen(sValue0)) + "\"\n\n";
    Comment(sComment);
    //====  / . =========================================================================================================================================
    sComment = sComment + "   BOOL: (" + FileMapWriteBoolArray(NameFileMap0, StartByte, abOutArray, ArraySize(abOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + abOutArray[i] + ", ";
      else sComment = sComment + abOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   BOOL: (" + FileMapReadBoolArray(NameFileMap0, StartByte, abIncArray, ArraySize(abIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + abIncArray[i] + ", ";
      else sComment = sComment + abIncArray[i] + "}\n";
     }
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + FileMapWriteCharArray(NameFileMap0, StartByte, acOutArray, ArraySize(acOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + acOutArray[i] + ", ";
      else sComment = sComment + acOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   CHAR: (" + FileMapReadCharArray(NameFileMap0, StartByte, acIncArray, ArraySize(acIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + acIncArray[i] + ", ";
      else sComment = sComment + acIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED CHAR: (" + FileMapWriteUnsCharArray(NameFileMap0, StartByte, aucOutArray, ArraySize(aucOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aucOutArray[i] + ", ";
      else sComment = sComment + aucOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED CHAR: (" + FileMapReadUnsCharArray(NameFileMap0, StartByte, aucIncArray, ArraySize(aucIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aucIncArray[i] + ", ";
      else sComment = sComment + aucIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   SHORT: (" + FileMapWriteShortArray(NameFileMap0, StartByte, ashOutArray, ArraySize(ashOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + ashOutArray[i] + ", ";
      else sComment = sComment + ashOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   SHORT: (" + FileMapReadShortArray(NameFileMap0, StartByte, ashIncArray, ArraySize(ashIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + ashIncArray[i] + ", ";
      else sComment = sComment + ashIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED SHORT: (" + FileMapWriteUnsShortArray(NameFileMap0, StartByte, aushOutArray, ArraySize(aushOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aushOutArray[i] + ", ";
      else sComment = sComment + aushOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED SHORT: (" + FileMapReadUnsShortArray(NameFileMap0, StartByte, aushIncArray, ArraySize(aushIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aushIncArray[i] + ", ";
      else sComment = sComment + aushIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   INT: (" + FileMapWriteIntArray(NameFileMap0, StartByte, aiOutArray, ArraySize(aiOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aiOutArray[i] + ", ";
      else sComment = sComment + aiOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   INT: (" + FileMapReadIntArray(NameFileMap0, StartByte, aiIncArray, ArraySize(aiIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aiIncArray[i] + ", ";
      else sComment = sComment + aiIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   FLOAT: (" + FileMapWriteFloatArray(NameFileMap0, StartByte, afOutArray, ArraySize(afOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + afOutArray[i] + ", ";
      else sComment = sComment + afOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   FLOAT: (" + FileMapReadFloatArray(NameFileMap0, StartByte, afIncArray, ArraySize(afIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + afIncArray[i] + ", ";
      else sComment = sComment + afIncArray[i] + "}\n";
     }
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   DOUBLE: (" + FileMapWriteDoubleArray(NameFileMap0, StartByte, adOutArray, ArraySize(adOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + adOutArray[i] + ", ";
      else sComment = sComment + adOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   DOUBLE: (" + FileMapReadDoubleArray(NameFileMap0, StartByte, adIncArray, ArraySize(adIncArray)) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + adIncArray[i] + ", ";
      else sComment = sComment + adIncArray[i] + "}\n\n";
     }
    Comment(sComment);  
    //====   . ==========================================================================================================================================
    sComment = sComment + " : (" + FileMapCloseHandle(hMapping) + ")\n";
    Comment(sComment);
    sComment = sComment + " .    \"" + NameFileMap0 + "\" . : " + FileMapOpen(NameFileMap0) + "\n\n"; //    .
    Comment(sComment);
    //        .        .
   }
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckWrite)
   {//====          . ==============================================================================
    nAddress = FileMapCreateViewOfFile(NULL, NameFileMap0, MemorySize);
    sComment = sComment + " \"" + NameFileMap0 + "\" . : " + nAddress + "\n";
    Comment(sComment);
    //====     . ==================================================================================================================================
    sComment = sComment + "   BOOL: ("           + FileMapSimpleWriteBool(nAddress, 0, bValue) + ")  " + bValue + "\n";
    sComment = sComment + "   CHAR: ("           + FileMapSimpleWriteChar(nAddress, 1, cValue) + ")  " + cValue + "\n";
    sComment = sComment + "   UNSIGNED CHAR: ("  + FileMapSimpleWriteUnsChar(nAddress, 2, ucValue) + ")  " + ucValue + "\n";
    sComment = sComment + "   SHORT: ("          + FileMapSimpleWriteShort(nAddress, 3, shValue) + ")  " + shValue + "\n";
    sComment = sComment + "   UNSIGNED SHORT: (" + FileMapSimpleWriteUnsShort(nAddress, 5, ushValue) + ")  " + ushValue + "\n";
    sComment = sComment + "   INT: ("            + FileMapSimpleWriteInt(nAddress, 7, nValue) + ")  " + nValue + "\n";
    sComment = sComment + "   FLOAT: ("          + FileMapSimpleWriteFloat(nAddress, 11, fValue) + ")  " + fValue + "\n";
    sComment = sComment + "   DOUBLE: ("         + FileMapSimpleWriteDouble(nAddress, 15, dValue) + ")  " + dValue + "\n";
    sComment = sComment + "   : ("         + FileMapSimpleWriteString(nAddress, 23, sBufferClaer50) + ")\n";
    sBuffer50 = sValue0; //    .       (     ).
                         //     .       .    .
    sComment = sComment + "   STRING: ("        + FileMapSimpleWriteString(nAddress, 23, sBuffer50) + ")  \"" + sValue0 + "\"\n";
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   BOOL: (" + FileMapSimpleWriteBoolArray(nAddress, 23 + 50, abOutArray, ArraySize(abOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + abOutArray[i] + ", ";
      else sComment = sComment + abOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + FileMapSimpleWriteCharArray(nAddress, 73 + 50, acOutArray, ArraySize(acOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + acOutArray[i] + ", ";
      else sComment = sComment + acOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED CHAR: (" + FileMapSimpleWriteUnsCharArray(nAddress, 123 + 50, aucOutArray, ArraySize(aucOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aucOutArray[i] + ", ";
      else sComment = sComment + aucOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   SHORT: (" + FileMapSimpleWriteShortArray(nAddress, 173 + 50, ashOutArray, ArraySize(ashOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + ashOutArray[i] + ", ";
      else sComment = sComment + ashOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED SHORT: (" + FileMapSimpleWriteUnsShortArray(nAddress, 223 + 50, aushOutArray, ArraySize(aushOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aushOutArray[i] + ", ";
      else sComment = sComment + aushOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   INT: (" + FileMapSimpleWriteIntArray(nAddress, 273 + 50, aiOutArray, ArraySize(aiOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + aiOutArray[i] + ", ";
      else sComment = sComment + aiOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   FLOAT: (" + FileMapSimpleWriteFloatArray(nAddress, 323 + 50, afOutArray, ArraySize(afOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + afOutArray[i] + ", ";
      else sComment = sComment + afOutArray[i];
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   DOUBLE: (" + FileMapSimpleWriteDoubleArray(nAddress, 373 + 50, adOutArray, ArraySize(adOutArray)) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + adOutArray[i] + ", ";
      else sComment = sComment + adOutArray[i];
     }
    sComment = sComment + "}\n\n";
    Comment(sComment);
    //====       . ========================================================================================================
    sComment = sComment + "   : (" + FileMapUnViewOfFile(nAddress) + ")\n"; // 
    Comment(sComment);
   }
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckRead)
   {//====   . ==========================================================================================================================================
    hMapping = FileMapCreate(NULL, NameFileMap0, MemorySize); //  .   ,  .       .
    sComment = " \"" + NameFileMap0 + "\" . : " + hMapping + "\n\n";
    Comment(sComment);
    Sleep(3000);
    while (CheckRead && !IsStopped())
     {//====     . ==============================================================================================================================
      ArrayInitialize(abIncArray, 0);
      ArrayInitialize(acIncArray, 0);
      ArrayInitialize(aucIncArray, 0);
      ArrayInitialize(ashIncArray, 0);
      ArrayInitialize(aushIncArray, 0);
      ArrayInitialize(aiIncArray, 0);
      ArrayInitialize(afIncArray, 0);
      ArrayInitialize(adIncArray, 0);
      //====         . =============================================================================
      nAddress = FileMapViewOfFile(hMapping);
      sComment = sComment + "      \"" + NameFileMap0 + "\". : " + nAddress + "\n\n";
      Comment(sComment);
      //====        . =====================================================================================================
      sComment = sComment + "   BOOL: "           + FileMapSimpleReadBool(nAddress, 0) + "\n";
      sComment = sComment + "   CHAR: "           + FileMapSimpleReadChar(nAddress, 1) + "\n";
      sComment = sComment + "   UNSIGNED CHAR: "  + FileMapSimpleReadUnsChar(nAddress, 2) + "\n";
      sComment = sComment + "   SHORT: "          + FileMapSimpleReadShort(nAddress, 3) + "\n";
      sComment = sComment + "   UNSIGNED SHORT: " + FileMapSimpleReadUnsShort(nAddress, 5) + "\n";
      sComment = sComment + "   INT: "            + FileMapSimpleReadInt(nAddress, 7) + "\n";
      sComment = sComment + "   FLOAT: "          + FileMapSimpleReadFloat(nAddress, 11) + "\n";
      sComment = sComment + "   DOUBLE: "         + FileMapSimpleReadDouble(nAddress, 15) + "\n";
      sComment = sComment + "   STRING: \""      + FileMapSimpleReadString(nAddress, 23) + "\"\n";
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   BOOL: (" + FileMapSimpleReadBoolArray(nAddress, 23 + 50, abIncArray, ArraySize(abIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + abIncArray[i] + ", ";
        else sComment = sComment + abIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   CHAR: (" + FileMapSimpleReadCharArray(nAddress, 73 + 50, acIncArray, ArraySize(acIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + acIncArray[i] + ", ";
        else sComment = sComment + acIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   UNSIGNED CHAR: (" + FileMapSimpleReadUnsCharArray(nAddress, 123 + 50, aucIncArray, ArraySize(aucIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + aucIncArray[i] + ", ";
        else sComment = sComment + aucIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   SHORT: (" + FileMapSimpleReadShortArray(nAddress, 173 + 50, ashIncArray, ArraySize(ashIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + ashIncArray[i] + ", ";
        else sComment = sComment + ashIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   UNSIGNED SHORT: (" + FileMapSimpleReadUnsShortArray(nAddress, 223 + 50, aushIncArray, ArraySize(aushIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + aushIncArray[i] + ", ";
        else sComment = sComment + aushIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   INT: (" + FileMapSimpleReadIntArray(nAddress, 273 + 50, aiIncArray, ArraySize(aiIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + aiIncArray[i] + ", ";
        else sComment = sComment + aiIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   FLOAT: (" + FileMapSimpleReadFloatArray(nAddress, 323 + 50, afIncArray, ArraySize(afIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + afIncArray[i] + ", ";
        else sComment = sComment + afIncArray[i];
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      sComment = sComment + "   DOUBLE: (" + FileMapSimpleReadDoubleArray(nAddress, 373 + 50, adIncArray, ArraySize(adIncArray)) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + adIncArray[i] + ", ";
        else sComment = sComment + adIncArray[i];
       }
      sComment = sComment + "}\n\n";
      Comment(sComment);
      //====       . ======================================================================================================
      sComment = sComment + "   : (" + FileMapUnViewOfFile(nAddress) + ")\n"; // 
      Comment(sComment);
      Sleep(5000);
      sComment = "";
     }
    sComment = sComment + "    : (" + FileMapCloseName(NameFileMap0 + "Simple") + ")\n";
    Comment(sComment);
    sComment = sComment + " . : " + FileMapOpenViewOfFile(NameFileMap0 + "Simple") + "\n\n";
    Comment(sComment);
   }
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckGeneral)
   {//====    . =====================================================================================================================================
    Comment(sComment);
    sComment = sComment + "1.  1 . : " + FileMapCreate(NULL, NameFileMap0 + "_1", MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "2.  2 . : " + FileMapCreate(NULL, NameFileMap0 + "_2", MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "1.  1 . : " + FileMapOpen(NameFileMap0 + "_1") + "\n";
    Comment(sComment);
    sComment = sComment + "2.  2 . : " + FileMapOpen(NameFileMap0 + "_2") + "\n";
    Comment(sComment);
    sComment = sComment + "  : (" + FileMapCloseAll("") + ")\n";
    Comment(sComment);
    sComment = sComment + "1.  .    1. : " + FileMapOpen(NameFileMap0 + "_1") + "\n";
    Comment(sComment);
    sComment = sComment + "2.  .    2. : " + FileMapOpen(NameFileMap0 + "_2") + "\n\n";
    Comment(sComment);
    //====      . ================================================================================================================
    sComment = sComment + "1. 1 . : " + FileMapCreate(NULL, NameFileMap0 + "_1", MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "2. 2 . : " + FileMapCreate(NULL, NameFileMap0 + "_2", MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "    : (" + FileMapCloseHandleFile(NULL) + ")\n";
    Comment(sComment);
    sComment = sComment + "1.  .    1. : " + FileMapOpen(NameFileMap0 + "_1") + "\n";
    Comment(sComment);
    sComment = sComment + "2.  .    2. : " + FileMapOpen(NameFileMap0 + "_2") + "\n\n";
    Comment(sComment);
    //====      . ========================================================================================================================
    sComment = sComment + "1. 1 . : " + FileMapCreate(NULL, NameFileMap0, MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "2. 2 . : " + FileMapCreate(NULL, NameFileMap0, MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "    : (" + FileMapCloseName(NameFileMap0) + ")\n";
    Comment(sComment);
    sComment = sComment + " .   . : " + FileMapOpen(NameFileMap0) + "\n\n";
    Comment(sComment);
    //====    . ===========================================================================================================================================
    sComment = sComment + "1. 1 . : " + FileMapCreate(NULL, NameFileMap1, MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "2. 2 . : " + FileMapCreate(NULL, NameFileMap2, MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "3. 3 . : " + FileMapCreate(NULL, NameFileMap3, MemorySize) + "\n";
    Comment(sComment);
    sComment = sComment + "4. 4 . : " + FileMapCreate(NULL, NameFileMap4, MemorySize) + "\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.   1  STRING: (" + FileMapWriteString(NameFileMap1, StartByte, sValue1) + ")  \"" + sValue1 + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.   2  STRING: (" + FileMapWriteString(NameFileMap2, StartByte, sValue2) + ")  \"" + sValue2 + "\"\n";
    Comment(sComment);
    sComment = sComment + "3.   3  STRING: (" + FileMapWriteString(NameFileMap3, StartByte, sValue3) + ")  \"" + sValue3 + "\"\n";
    Comment(sComment);
    sComment = sComment + "4.   4  STRING: (" + FileMapWriteString(NameFileMap4, StartByte, sValue4) + ")  \"" + sValue4 + "\"\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.   1  STRING: \"" + FileMapReadString(NameFileMap1, StartByte, sBuffer25, StringLen(sValue1)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.   2  STRING: \"" + FileMapReadString(NameFileMap2, StartByte, sBuffer25, StringLen(sValue2)) + "\"\n"; //   sBuffer25     .
    Comment(sComment);
    sComment = sComment + "3.   3  STRING: \"" + FileMapReadString(NameFileMap3, StartByte, sBuffer25, StringLen(sValue3)) + "\"\n"; //   sBuffer25     .
    Comment(sComment);
    sComment = sComment + "4.   4  STRING: \"" + FileMapReadString(NameFileMap4, StartByte, sBuffer25, StringLen(sValue4)) + "\"\n"; //   sBuffer25     .
    Comment(sComment);
    sComment = sComment + "    (" + NamePrefix + ")  : (" + FileMapCloseAll(NamePrefix) + ")\n";
    Comment(sComment);
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.  .   1  STRING: \"" + FileMapReadString(NameFileMap1, StartByte, sBuffer25, StringLen(sValue1)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.  .   2  STRING: \"" + FileMapReadString(NameFileMap2, StartByte, sBuffer25, StringLen(sValue2)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "3.  .   3  STRING: \"" + FileMapReadString(NameFileMap3, StartByte, sBuffer25, StringLen(sValue3)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "4.  .   4  STRING: \"" + FileMapReadString(NameFileMap4, StartByte, sBuffer25, StringLen(sValue4)) + "\"\n";
    Comment(sComment);
    sComment = sComment + " : (" + FileMapCloseAll("") + ")\n\n";
    Comment(sComment);
    //====   . ===========================================================================================================================================
    sComment = sComment + " . : " + FileMapCreate(NULL, NameFileMap0, 10) + "\n";
    Comment(sComment);
    sComment = sComment + "   STRING: (" + FileMapWriteString(NameFileMap0, StartByte, sValue0) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    //         .        .
    sComment = sComment + "   STRING:             \"" + FileMapReadString(NameFileMap0, StartByte + 20, sBuffer50, StringLen(sValue0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + FileMapResize(NameFileMap0, 50) + ")\n";
    Comment(sComment);
    //   .    ,    .
    sComment = sComment + "   STRING: (" + FileMapWriteString(NameFileMap0, StartByte + 20, sValue0) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    //         .
    sComment = sComment + "   STRING:             \"" + FileMapReadString(NameFileMap0, StartByte, sBuffer50, StringLen(sValue0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + FileMapCloseAll("") + ")\n\n";
    Comment(sComment);
    //====   . ================================================================================================================================================
    sComment = sComment + " . : " + FileMapCreate(NULL, NameFileMap0, 1000) + "\n";
    Comment(sComment);
    sComment = sComment + "   STRING: (" + FileMapWriteString(NameFileMap0, StartByte, sValue0) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + FileMapReadString(NameFileMap0, StartByte, sBuffer50, StringLen(sValue0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + FileMapClear(NameFileMap0) + ")\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + FileMapReadString(NameFileMap0, StartByte, sBuffer50, StringLen(sValue0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + FileMapCloseAll("") + ")\n\n";
    Comment(sComment);
   }
 }
//